<template>
  <div class="form-group">
    <label :for="name">{{ label }}</label>
    <input
      autocomplete="off"
      @input="updateField" v-model.trim="value" :id="name" type="text" :class="errorClassObject"
      class="form-control"    
      :placeholder="placeholder"
    >

    <p class="text-danger" v-text="errorMessage()">Error Here</p>
  </div>
</template>

<script>
  export default {
    name: "InputField",
    props: [
      'name', 'label', 'placeholder', 'errors', 'data'
    ],
    data() {
      return {
        value: '',
      }
    },
    computed: {
      hasError() {
        return this.errors && this.errors[this.name] && this.errors[this.name].length > 0
      },
    },
    methods: {
      updateField() {
        this.clearErrors()
        this.$emit('update:field', this.value)
      },
      errorMessage() {
        if (this.hasError) {
          return this.errors[this.name][0]
        }
      },
      clearErrors() {
        if (this.hasError) {
          this.errors[this.name] = null
        }
      },
      errorClassObject() {
        return {
          'error-field': this.hasError
        }
      }
    },
    watch: {
      data(val) {
        this.value = val
      }
    }
  }
</script>
